import Action from '@overflow/commons/redux/Action';
import InfraOSPort from '../..//api/model/InfraOSPort';

import InfraOSPortRegistPayload from '../payload/InfraOSPortRegistPayload';

// Action Type
export type REQUEST = '@overflow/infraMachine/regist/REQUEST';
export type REQUEST_SUCCESS = '@overflow/infraMachine/regist/REQUEST_SUCCESS';
export type REQUEST_FAILURE = '@overflow/infraMachine/regist/REQUEST_FAILURE';

export const REQUEST: REQUEST = '@overflow/infraMachine/regist/REQUEST';
export const REQUEST_SUCCESS: REQUEST_SUCCESS = '@overflow/infraMachine/regist/REQUEST_SUCCESS';
export const REQUEST_FAILURE: REQUEST_FAILURE = '@overflow/infraMachine/regist/REQUEST_FAILURE';

// Action Creater
export type request = (infraOSPort: InfraOSPort) => Action<InfraOSPortRegistPayload>;
export type requestSuccess = (infraOSPort: InfraOSPort) => Action<InfraOSPort>;
export type requestFailure = (error: Error) => Action;



export const request: request = (infraOSPort: InfraOSPort): Action<InfraOSPortRegistPayload> => {
  return {
      type: REQUEST,
      payload: {
        infraOSPort:infraOSPort,
      },
    };
};

export const requestSuccess: requestSuccess = (infraOSPort: InfraOSPort): Action<InfraOSPort> => {
  return {
      type: REQUEST_SUCCESS,
      payload: infraOSPort,
    };
};

export const requestFailure: requestFailure = (error: Error): Action => {
  return {
      type: REQUEST_FAILURE,
      error: error,
    };
};
