import Action from '@overflow/commons/redux/Action';
import InfraService from '../..//api/model/InfraService';

import InfraServiceRegistPayload from '../payload/InfraServiceRegistPayload';

// Action Type
export type REQUEST = '@overflow/infraMachine/regist/REQUEST';
export type REQUEST_SUCCESS = '@overflow/infraMachine/regist/REQUEST_SUCCESS';
export type REQUEST_FAILURE = '@overflow/infraMachine/regist/REQUEST_FAILURE';

export const REQUEST: REQUEST = '@overflow/infraMachine/regist/REQUEST';
export const REQUEST_SUCCESS: REQUEST_SUCCESS = '@overflow/infraMachine/regist/REQUEST_SUCCESS';
export const REQUEST_FAILURE: REQUEST_FAILURE = '@overflow/infraMachine/regist/REQUEST_FAILURE';

// Action Creater
export type request = (infraService: InfraService) => Action<InfraServiceRegistPayload>;
export type requestSuccess = (infraService: InfraService) => Action<InfraService>;
export type requestFailure = (error: Error) => Action;



export const request: request = (infraService: InfraService): Action<InfraServiceRegistPayload> => {
  return {
      type: REQUEST,
      payload: {
        infraService:infraService,
      },
    };
};

export const requestSuccess: requestSuccess = (infraService: InfraService): Action<InfraService> => {
  return {
      type: REQUEST_SUCCESS,
      payload: infraService,
    };
};

export const requestFailure: requestFailure = (error: Error): Action => {
  return {
      type: REQUEST_FAILURE,
      error: error,
    };
};
